{% extends 'base.html' %}
{% load static %}
{% load cartCount %}
{% load rentalCartCount %}

{% block title %}
My Cart | Book-ed
{% endblock %}

{% block content %}
<div class="container-fluid">
    <div class="row">
        <div class="col-xs-12">
            <div class='parallax'>
                <h2 style="text-align: center;">My Cart</h2>
                {% if user|cartNum %}
                <div class='table-responsive'>

                    <table class='table table-striped'>
                        <thead>
                            <tr class="row">
                                <th class="col-md-3 col-xs-3 col-sm-3">Title</th>
                                <!-- <th>Security (Refundable)</th> -->
                                <!-- <th>Rent (Non-refundable)</th> -->
                                <th class="col-md-3 col-xs-3 col-sm-3">Total Payable Amount</th>
                                <th class="col-md-3 col-xs-3 col-sm-3">Buy/Rent</th>
                                <th class="col-md-3 col-xs-3 col-sm-3">Remove from Cart</th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for i,type,amount in items %}
                            <tr class="row">
                                <td class="col-md-3 col-xs-3 col-sm-3">
                                    <a href='/books/{{ i.book.pk}}/'>{{ i.book.title }}</a>
                                </td>
                                <td class="col-md-3 col-xs-3 col-sm-3">
                                    {{ amount }}
                                </td>
                                <td class="col-md-3 col-xs-3 col-sm-3">
                                    {{ type }}
                                </td>
                                <td class="col-md-3 col-xs-3 col-sm-3">
                                    {% if type == 'Rent' %}
                                    <a href='/books/{{i.pk}}/removeFromRentalCart/'>Remove</a>
                                    {% else %}
                                    <a href='/books/{{i.pk}}/removeFromCart/'>Remove</a>
                                    {% endif %}
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>

                <div class='col-xs-12'>
                    Total: {{ totalAmount }}
                    <button type="button" class="modal-button btn btn-lg btn-info"  data-toggle="modal" data-target="#verificationModal">Checkout</button>
                </div>
                {% else %}
                <h2 style="text-align: center;">No Items Here! <img src="/static/img/emoticon.png" style="height:50px;"/></h2>
                {% endif %}
            </div>
        </div>
    </div>
    <!-- <div class="row"> -->
    <!--     <div class="col-xs-12"> -->
    <!--         <div class="absolute"> -->
    <!--             <div class="parallaxWhite"> -->
    <!--                 <1!-- Content Here --1> -->
    <!--             </div> -->
    <!--         </div> -->
    <!--     </div> -->
    <!-- </div> -->
</div>

<!-- Container element -->
<!-- <div class="parallax"></div> -->

<!-- Verification Modal -->
<div id="verificationModal" class="modal fade" role="dialog">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal">&times;</button>
                <h4 class="modal-title">Checkout</h4>
            </div>
            


            <div class="verification" style="margin-top:25px;">

                <div class="row">
                    <div class="col-md-10 col-md-offset-1 col-xs-11 col-xs-offset-1 col-sm-11 col-sm-offset-1">
                        <h4 class="modal-title">We need to send the OTP to registered mobile number or Email ID</h4>
                    </div>
                    <div class="col-md-10 col-md-offset-1 col-xs-11 col-sm-11">
                        <div class="row" style="margin-top: 10px;">
                            <form action="#" method="get" accept-charset="utf-8">



                                <div class="row" style="margin-top: 20px;">
                                    <span class="verify_require col-md-5 col-md-offset-1 col-xs-5 col-sm-5 col-sm-offset-1 col-xs-offset-1" style="font-size:20px;">Total Items</span>
                                    <input type="hidden" name="amount"  value="{{ items|length }}">
                                    <input value="{{ items|length }}" readonly  class="col-md-4 col-xs-4 col-sm-4" style="margin-top: 8px;width:180px !important;" type="number">
                                </div>



                                <div class="row" style="margin-top: 20px;">
                                    <span class="verify_require col-md-5 col-md-offset-1 col-xs-5 col-sm-5 col-sm-offset-1 col-xs-offset-1" style="font-size:20px;">Total Rented books</span>
                                    <input type="hidden" name="amount" value="{{ numOfRentedBooks }}">
                                    <input value="{{ numOfRentedBooks }}" readonly class="col-md-4 col-xs-4 col-sm-4" style="margin-top: 8px;width:180px !important;" type="number">
                                </div>

                                {% if numOfRentedBooks == 1 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 60 + Re. 1/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks == 2 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 110 + Re. 1/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks  == 3 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 150 + Rs. 1.5/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks == 4 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 190 + Re. 2/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks == 5 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 230 + Re. 2/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks == 6 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 270 + Re. 2.5/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks == 7 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 320 + Re. 2.5/day </span>
                                    
                                    </div>
                                {% endif %}
                                {% if numOfRentedBooks == 8 %}
                                    <div class="row" style="margin-top: 20px;">
                                            <span class="col-md-10  col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1 col-md-offset-1" style="font-size:20px;">This will cost you Rs. 370 + Re. 3/day </span>
                                    
                                    </div>
                                {% endif %}
                                

                                <div id='rentRow1' class="days row" style="margin-top:20px;">
                                <div class="col-md-11 col-xs-11 col-sm-11">
                                    <span class="col-sm-2 col-md-2 col-xs-3">Days</span>
                                        <div class="col-sm-10  col-md-8  col-xs-9" style="margin-bottom:8px;">
                                            <div class="demo">
                                                                                                            <!-- rkmd-slider -->
                                                
                                                    <input class="data_days" id="duration" name="duration" type="range" min="3" max="60" value="7" onchange="changeValues();" oninput="changeValues();" onmouseover="changeValues();">
                                                <!-- @end rkmd-slider -->
                                            </div>      
                                        </div>
                                    <div class="row">
                                        <div class="col-md-offset-2 col-sm-offset-2 col-xs-offset-3" style="">
                                            <span class="col-md-5 col-sm-5 col-xs-5">3 days</span>
                                        </div>

                                        <div class="col-md-offset-7 col-xs-offset-6 col-sm-offset-6" style="float:right;">
                                            <span class="col-md-12 col-xs-12 col-sm-7">
                                                60 days
                                            </span>
                                        </div>
                                    </div>
                                </div>
                                </div>

<!--                                

                                please check this

                                    <input type="text" id="no_of_days" class="modals-input col-sm-4 col-md-offset-1 col-md-4 col-sm-offset-1 col-xs-4 col-xs-offset-1" readonly value="7 days">

                                please check this .. -->

                                
                                 <div id='rentRow2' class="row" style="margin-top:5px;">

                                <div class="row" style="margin-top: 20px;">
                                    <span class="verify_require col-md-5 col-md-offset-1 col-xs-5 col-sm-5 col-sm-offset-1 col-xs-offset-1" style="font-size:20px;">No. of Days for Rent</span>
                                    <input type="text" id="no_of_days" class="form-control col-md-4 col-xs-4 col-sm-4" value="7 days" readonly="" style="margin-top: 8px;width:180px !important;">
                                    
                                </div>

                                </div>

                                <div id='rentRow3' class="row" style="margin-top:15px;">
                                    <span class="col-sm-1 col-md-1 col-xs-1" style='padding-top:5px;color:#212121;display:inline;'>
                                        Price
                                    </span>
                                        <input id='rentVal' readonly type="text" class="col-md-2 col-xs-2 col-sm-2" value="">

                                        <span class="col-md-1 col-xs-1 col-sm-1">+</span>

                                        <input id='securityVal' readonly type="text" class="col-md-2 col-xs-2 col-sm-2" value="">

                                        <span class="col-md-1 col-xs-1 col-sm-1">=</span>

                                        <input id='totalVal' readonly type="text" class="col-md-2 col-xs-2 col-sm-2" value="">
                                </div>

                                <div id='rentRow4' class="row" style="margin-top:3px;">

                                    <span style="font-size:20px;text-align:center;" class=" col-md-3 col-xs-3 col-sm-3">Rent</span>
                                    <span style="font-size:20px;text-align:center;" class=" col-md-3 col-xs-3 col-sm-3">Security</span>
                                    <span style="font-size:20px;text-align:center;" class=" col-md-3 col-xs-3 col-sm-3">Payable Amount</span>
                                        <!-- <button type="button" type="submit" class="form1" style="visibility:hidden;">Done</button> -->
                                </div>


                                <div class="row" style="margin-top: 10px;">
                                    <span class="verify_require col-md-10 col-md-offset-1 col-xs-10 col-sm-10 col-sm-offset-1 col-xs-offset-1" style="font-size:20px;">Shipping Address</span> 
                                    <textarea class="form-control col-md-7 col-md-offset-2 col-xs-7 col-xs-offset-1 col-sm-7 col-sm-offset-1" name="address" id="address" rows="2" style="width:400px;margin-top: 10px;"> </textarea>
                                </div>
                                


                                 <!-- <div class="row" style="margin-top: 20px;">
                                    <span class="verify_require col-md-5 col-md-offset-1 col-xs-5 col-sm-5 col-sm-offset-1 col-xs-offset-1" style="font-size:20px;">No. of Days for Rent</span>
                                    <input type="number" name ="duration" id="duration" class="form-control col-md-4 col-xs-4 col-sm-4" value="" style="margin-top: 8px;width:180px !important;">
                                    
                                </div> -->



                                <!-- Number of Days for renting
                                <input class="form-control" type="number" name="duration" id="duration" value="" style="color:white;margin-top:10px;"> -->
                                <div  class="row" style="margin-top:15px;margin-right: 10px;margin-left: 10px;">

                                            <span class="col-sm-1 col-md-1 col-xs-1" style='padding-top:5px;color:#212121;display:inline;'>Price</span>
                                            <input readonly type="text" class="col-md-2 col-xs-2 col-sm-2" value="{{ rentCost }}" style="font-size: 15px;">
                                            <span class="col-md-1 col-xs-1 col-sm-1">+</span>
                                            <input readonly type="text" class="col-md-2 col-xs-2 col-sm-2" value="{{ buyCost }}" style="font-size: 15px;">
                                            <span class="col-md-1 col-xs-1 col-sm-1">=</span>
                                            <input readonly type="text" class="col-md-2 col-xs-2 col-sm-2" value="{{ totalAmount }}" style="font-size:15px;"  >
                                </div>


                                <div class="row" style="margin-top:3px;margin-right: 10px;margin-left: 10px;">

                                            <span style="font-size:20px;text-align:center;" class=" col-md-3 col-xs-3 col-sm-3">Rent</span>
                                            <span style="font-size:20px;text-align:center;" class=" col-md-3 col-xs-3 col-sm-3">Purchase</span>
                                            <span style="font-size:20px;text-align:center;" class=" col-md-3 col-xs-3 col-sm-3">Total</span>

                                </div>


                                <div class="row" style="margin-top: 20px;">
                            <span class="verify_require col-md-5 col-xs-5 col-sm-5 col-sm-offset-1" style="font-size:20px;text-align: center;">Amount</span>
                            <input type="hidden" name="amount" id="amount" value="{{ totalAmount }}">
                            <input value="{{ totalAmount }}" readonly id='amountSpan' class="col-md-4 col-xs-5 col-xs-offset-1 col-sm-4" style="margin-top: 8px;width:180px !important;" type="number">
                                </div>



                                <div class="row" style="margin-top: 20px;">
                                    <span class="verify_require col-md-5 col-md-offset-1 col-xs-5 col-sm-5 col-sm-offset-1 col-xs-offset-1" style="font-size:20px;">Payment Option</span>

                                    <select class="form-control col-md-4 col-xs-6 col-sm-4 " name="paymentOption" id="paymentOption" onchange="" size="1" style="width:180px !important;">
                                        <option value="COD">Cash On Delivery</option>
<!--                                         <option value="Online">Online Payment (Netbanking, Debit Cards etc)</option> -->
                                    </select>
                                </div>

                                <!-- Rent from Date -->
                                <!-- TODO: Show calendar -->
                                <!-- <input type="text" name="startDate" id="startDate" class='form-control' placeholder='dd-mm-yy' value=""> -->
                                <!-- <div class="row" style="margin-top: 20px;"> -->
                                <!--     <span class="verify_require col-md-6 col-md-offset-1 col-xs-6 col-sm-6 col-sm-offset-1 col-xs-offset-1" id='labelDuration' for="duration" style="font-size:20px;">No. of days for renting</span> -->
                                <!--     <input class="form-control col-md-3 col-md-offset-1 col-xs-3 col-sm-3 col-xs-offset-1 col-sm-offset-1" type="number" name="duration" id="duration" value="" min="3" max="60" style="width:100px !important;"> -->
                                <!-- </div> -->




                                <!-- OTP queries -->
                                <div class="row">
                                    <div id="otpError" class="col-md-10 col-md-offset-1 col-xs-8 col-xs-offset-2 col-sm-8 col-sm-offset-2" style="color:#CDDC39;display:none;">
                                        <h3>There was an error trying to send the otp. Please try again later!</h3>
                                    </div>

                                    <div id="incorrectOtp" class="col-md-10 col-md-offset-1 col-xs-8 col-xs-offset-2 col-sm-8 col-sm-offset-2" style="color:#F44336;display:none;">
                                        <h3>The OTP you entered was incorrect or already used by you.</h3>
                                    </div>

                                    <div id="otpVerify" class="col-md-10 col-md-offset-1 col-xs-10 col-xs-offset-1 col-sm-10 col-sm-offset-1" style="display:none;">
                                        <h3>An OTP has been sent to your mobile number and email id.</h3>
                                        Enter OTP:<input class="form-control" type="text" name="otp" id="otp" value=""> 
                                        <button id='otpVerifyBtn' type="button" class="btn btn-info modal-button" onclick='verifyOtp();' style="width:auto !important;">Verify and Confirm Order</button>
                                    </div>
                                </div>

                                <!-- OTP queries end -->




                                <div class="col-md-3 col-md-offset-1 col-xs-3 col-xs-offset-1 col-sm-3 col-sm-offset-1">
                                    <button id='sendOtpBtn' type="button" class="btn btn-info modal-button" onclick='sendOtp();' style="">Send OTP</button>
                                </div>

                                <div class="col-xs-12" id="shipping">
                                    <label>Shipping Charges may apply*</label>
                                </div>
                                <div class="col-xs-12" id="shippingText">
                                    <label>For order below Rs.200 shipping charges will apply of Rs.30 only</label>
                                </div>

                            </form>
                        </div>
                    </div>

                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="modal-button btn btn-default" data-dismiss="modal">Cancel</button>
            </div>
        </div>

    </div>
</div>
<!-- Verification Modal -->

<div id="hiddenForm" class="name">
</div>

<script type="text/javascript" charset="utf-8">



function shipping(){
    var x= 0;
    var y = $("#shippingText");
        y.hide();
        $("#shipping").click(function(){
        console.log("clicked" + x);
        x++;
        if(x%2 == 0){
            y.hide();
        }
        else{
            y.show();
        }
            
    });

}
function sendOtp() {
    document.getElementById("sendOtpBtn").innerHTML = 'Please Wait...';
    var xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            resp = JSON.parse(this.responseText);
            console.log(resp);
            if(resp['status'] = 'sent')
            {
                document.getElementById("otpVerify").style.display = 'block';
                
            }
            else
            {
                document.getElementById("otpVerify").style.display = 'none';
                document.getElementById("otpError").style.display = 'block';
                

            }
            document.getElementById('sendOtpBtn').innerHTML = 'Resend OTP';

    };
        }

    var url = '/sendOtp/';
    xhttp.open("GET", url, true);
    xhttp.send();
}

function verifyOtp() {
    document.getElementById('otpVerifyBtn').value = 'Verifying...';
    document.getElementById('otpVerifyBtn').disabled = true;
    var xhttp = new XMLHttpRequest();
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            resp = JSON.parse(this.responseText);
            if(resp['status'] == 'Verified')
            {
                document.getElementById('otpVerifyBtn').value = 'Please Wait';
                document.getElementById("incorrectOtp").style.display = 'none';
                //redirect to success page
                var paymentOption =  document.getElementById('paymentOption').value;
                if(paymentOption == 'COD')
                {
                    //Order complete: Nothing else to do
                    //Post the id that came in response to success page
                    $('#hiddenForm').html('<form action="/books/orderComplete/" name="formSuccess" method="get" style="display:none;"><input type="text" name="shipmentPk" value="' + resp['id'] + '" /></form>');
                    document.forms['formSuccess'].submit();
                }
                else
                {
                    //Show razorpay payment gateway; collect payment and post the details to onlinePayment page
                    var totalAmount = (resp['amount']*100).toString();
                    var options = {
                        "key": "rzp_test_7Kw2wESOi945RD",
                        "amount": totalAmount, // 100 paise = INR 1
                        "name": "Book-ed",
                        "description": "Book-ed Online Payment",
                        //"image": "/your_logo.png",
                        "handler": function (response){
                            //Send values to onlinePayment endpoint
                            $('#hiddenForm').html('<form action="/books/cart/onlinePayment/" name="formSuccess" method="post" style="display:none;"><input type="text" name="paymentId" value="' + response.razorpay_payment_id + '" /><input type="text" name="shipmentId" value="' + resp['id'] + '" /></form>');
                            document.forms['formSuccess'].submit();
                        },
                        "prefill": {
                            "name": "",
                            "email": ""
                        },
                        "notes": {
                            "address": ""
                        },
                        "theme": {
                            "color": "#F37254"
                        }
                    };

                    var rzp1 = new Razorpay(options);
                    rzp1.open();
                }
            }
            else
            {
                document.getElementById("incorrectOtp").style.display = 'block';
                document.getElementById('otpVerifyBtn').value = 'Verify';
            }
            document.getElementById("sendOtpBtn").innerHTML = 'Resend OTP';
        }
    };

    var url = '/verifyOtp/';
    var params = '';
    var enteredOtp = document.getElementById('otp').value;
    var address =  document.getElementById('address').value;
    var amount =  "{{ totalAmount }}";
    var paymentOption =  document.getElementById('paymentOption').value;
    var duration =  document.getElementById('duration').value;
    //var startDate =  document.getElementById('startDate').value;

    

    params += 'otp='+enteredOtp + '&paymentOption=' + paymentOption + '&address=' + address + '&duration=' + duration;

    xhttp.open("POST", url, true);
    xhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xhttp.send(params);
}

// function changeValues(){
//     console.log("calling");
//     var numDays = document.getElementById('duration').value;
//     numDays = parseInt(numDays);
//     document.getElementById("no_of_days").value = numDays + " days";
// }



function setBuyOrRent(val) {
    //0 = buy; 1 = rent
    if(val == 0)
    {
         
        document.getElementById('duration').style.display = 'none';
        //document.getElementById('labelDuration').style.display = 'none';
        // document.getElementById('amountSpan').innerHTML = '{{ sellingPrice }}';

        document.getElementById('rentRow1').style.display = 'none';
        document.getElementById('rentRow2').style.display = 'none';
        document.getElementById('rentRow3').style.display = 'none';
        document.getElementById('rentRow4').style.display = 'none';

        buyOrRent = 'Buy';
    }
    else
    {
         
        document.getElementById('duration').style.display = 'block';
        //document.getElementById('labelDuration').style.display = 'block';
        // document.getElementById('amountSpan').innerHTML = '{{ sellingPrice }}';

        document.getElementById('rentRow1').style.display = 'block';
        document.getElementById('rentRow2').style.display = 'block';
        document.getElementById('rentRow3').style.display = 'block';
        document.getElementById('rentRow4').style.display = 'block';

        buyOrRent = 'Rent';
    }
}

function changeValues() {
    //change values of rent modal
    var data = {
    "1" :[60,1],
    "2":[110,1],
    "3":[150,1.5],
    "4":[190,2],
    "5":[230,2],
    "6":[270,2.5],
    "7":[320,2.5],
    "8":[370,3]
};
   rent = data["{{ numOfRentedBooks }}"][0];
   perDayRent = data["{{ numOfRentedBooks }}"][1];
   totalPrice = {{ totalAmount }};
   sellingPrice = {{ rentCost }};
    
    if(totalPrice < 200)
    {
        shippingCharges = 30;
    }
    else {
        shippingCharges = 0
    }
    numDays = document.getElementById('duration').value;
    numDays = parseInt(numDays);
    rentVal = numDays*perDayRent + rent;

    if(rentVal > sellingPrice)
        rentVal = sellingPrice;

    security = sellingPrice - rentVal; 
    if(security < 0)
        security = 0;
    document.getElementById('rentVal').value = rentVal; //60(basic) + 1re per day
    document.getElementById('securityVal').value = security; //total amount paid is 70% of the book
    document.getElementById('no_of_days').value = numDays + ' days';
    document.getElementById("totalVal").value = sellingPrice ;  //show value in input box

}

$( document ).ready(function() {

    var data = {
    "1" :[60,1],
    "2":[110,1],
    "3":[150,1.5],
    "4":[190,2],
    "5":[230,2],
    "6":[270,2.5],
    "7":[320,2.5],
    "8":[370,3]
};

    //set default values of rent modal
    //here selling price is Total rent

    rent = data["{{ numOfRentedBooks }}"][0];
    perDayRent = data["{{ numOfRentedBooks }}"][1];
    totalPrice = {{ totalAmount }}
    sellingPrice = {{ rentCost }}
    if(totalPrice < 200)
    {
        shippingCharges = 30;
    }
    else {
        shippingCharges = 0
    }

    numDays = 7; 
    rentVal = numDays*perDayRent + rent;
    security = sellingPrice - rentVal; 
    if(security < 0)
        security = 0;
    if(rentVal > sellingPrice)
        rentVal = sellingPrice;
    document.getElementById('totalVal').value = String(sellingPrice);
    document.getElementById('rentVal').value = rentVal; 
    document.getElementById('securityVal').value = security;

    setBuyOrRent(1);

   
});
shipping();
changeValues();

</script>

<script src="https://checkout.razorpay.com/v1/checkout.js"></script>
{% endblock %}



